<?php

namespace app\admin\controller\device;

use app\common\controller\Backend;
use app\admin\model\Task;
use fast\Arr;
use think\Db;
use think\exception\PDOException;
use think\exception\ValidateException;

/**
 * 设备管理
 *
 * @icon fa fa-circle-o
 */
class Device extends Backend
{

    /**
     * Device模型对象
     * @var \app\admin\model\Device
     */
    protected $model = null;

    public function _initialize()
    {
        parent::_initialize();
        $this->model = new \app\admin\model\Device;
        $this->view->assign("statusList", $this->model->getStatusList());
    }



    /**
     * 默认生成的控制器所继承的父类中有index/add/edit/del/multi五个基础方法、destroy/restore/recyclebin三个回收站方法
     * 因此在当前控制器中可不用编写增删改查的代码,除非需要自己控制这部分逻辑
     * 需要将application/admin/library/traits/Backend.php中对应的方法复制到当前控制器,然后进行修改
     */
    /**
     * 查看
     */
    public function index()
    {
        //设置过滤方法
        $this->request->filter(['strip_tags', 'trim']);
        if ($this->request->isAjax()) {
            //如果发送的来源是Selectpage，则转发到Selectpage
            if ($this->request->request('keyField')) {
                return $this->selectpage();
            }
            list($where, $sort, $order, $offset, $limit) = $this->buildparams();
            $list = $this->model
                ->with(['group', 'task'])
                ->where($where)
                ->order($sort, $order)
                ->paginate($limit);
            $result = array("total" => $list->total(), "rows" => $list->items());

            return json($result);
        }
        return $this->view->fetch();
    }

    function task()
    {
        if ($this->request->isAjax()) {
            if (false === $this->request->isPost()) {
                $this->error(__('Invalid parameters'));
            }
            $ids = Arr::get($this->request->post('row/a'), 'ids',);
            if (empty($ids)) {
                $this->error(__('Parameter %s can not be empty', 'ids'));
            }
            $count = 0;
            Db::startTrans();
            try {
                $list = $this->model->where($this->model->getPk(), 'in', explode(',', $ids))->select();
                foreach ($list as $item) {
                    $count += $item->allowField(true)->isUpdate(true)->save([
                        'task_id' => Arr::get($this->request->param('row/a'), 'task_id'),
                        'status' => 0,
                    ]);
                }
                Db::commit();
            } catch (PDOException|Exception $e) {
                Db::rollback();
                $this->error($e->getMessage());
            }
            if ($count) {
                $this->success();
            }
            $this->error(__('No rows were updated'));
        }
        $this->view->assign('taskList', Task::getTaskList());
        return $this->view->fetch();
    }

    function taskSrart()
    {
        $server = 'broker.emqx.io';
        $port = 1883;
        $clientId = 'test-publisher';

        $mqtt = new \PhpMqtt\Client\MQTTClient($server, $port, $clientId);
        $mqtt->connect();
        $mqtt->publish('testtopic/1001', 'start', 0);
        $mqtt->close();
    }

    function taskStop()
    {

    }
}
